Please note: This project is no longer active. The website is kept online for historic purposes only.
If you´re looking for a Linux driver for your Atheros WLAN device, you should continue here .

Ticket #716 (closed defect: fixed)

Opened 13 years ago

Last modified 12 years ago

macchanger on wifi0 causes segfault/oops if interface hasnt been brought up at least once

Reported by: cf_0x2102@hotmail.com Assigned to:
Priority: minor Milestone:
Component: madwifi: other Version: trunk
Keywords: Cc:
Patch is attached: 0 Pending:

Description

Running r1634 on an ar5212.

Trying to follow the docs at http://madwifi.org/wiki/UserDocs/ChangeMacAddress

I am destroying all VAPs (well just the one really), running:

macchanger -A wifi0

If I don't bring wifi0 or ath0 up at least once before I do this I get a segfault from macchanger and the oops pasted below.

For the time being, (I'm running Ubuntu, of course Debian based) I'm working around the issue by having /etc/network/interfaces force wifi0 up and then rc.local brings it back down. Again, this is simply to have 'woken up' the NIC at least once, after which macchanger works as expected.

Anyone else see this ? Here is my ath dmesg info as well.

[4294685.584000] wifi0: 11a rates: 6Mbps 9Mbps 12Mbps 18Mbps 24Mbps 36Mbps
48Mbps 54Mbps
[4294685.584000] wifi0: 11b rates: 1Mbps 2Mbps 5.5Mbps 11Mbps
[4294685.584000] wifi0: 11g rates: 1Mbps 2Mbps 5.5Mbps 11Mbps 6Mbps 9Mbps
12Mbps 18Mbps 24Mbps 36Mbps 48Mbps 54Mbps
[4294685.584000] wifi0: turboA rates: 6Mbps 9Mbps 12Mbps 18Mbps 24Mbps
36Mbps 48Mbps 54Mbps
[4294685.585000] wifi0: H/W encryption support: WEP AES AES_CCM TKIP
[4294685.585000] wifi0: mac 5.6 phy 4.1 5ghz radio 1.7 2ghz radio 2.3
[4294685.585000] wifi0: Use hw queue 1 for WME_AC_BE traffic
[4294685.585000] wifi0: Use hw queue 0 for WME_AC_BK traffic
[4294685.585000] wifi0: Use hw queue 2 for WME_AC_VI traffic
[4294685.585000] wifi0: Use hw queue 3 for WME_AC_VO traffic
[4294685.585000] wifi0: Use hw queue 8 for CAB traffic
[4294685.585000] wifi0: Use hw queue 9 for beacons
[4294685.600000] wifi0: Atheros 5212: mem=0xd0200000, irq=209

Jun 22 19:06:59 0x0001 kernel: [4294781.005000] Unable to handle kernel
NULL pointer dereference at virtual address 00000000
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]  printing eip:
Jun 22 19:06:59 0x0001 kernel: [4294781.005000] d8b0ffa2
Jun 22 19:06:59 0x0001 kernel: [4294781.005000] *pde = 00000000
Jun 22 19:06:59 0x0001 kernel: [4294781.005000] Oops: 0000 [#1]
Jun 22 19:06:59 0x0001 kernel: [4294781.005000] PREEMPT SMP
Jun 22 19:06:59 0x0001 kernel: [4294781.005000] Modules linked in:
wlan_scan_sta radeon drm vmnet vmmon ipt_LOG ipt_limit ipt_state
ip_conntra
ck nfnetlink iptable_filter ip_tables cisco_ipsec rfcomm l2cap bluetooth
ipv6 ppdev acpi_cpufreq speedstep_lib cpufreq_userspace cpufreq_stats
  freq_table cpufreq_powersave cpufreq_ondemand cpufreq_conservative video
tc1100_wmi sony_acpi pcc_acpi hotkey dev_acpi container button acpi_
sbs battery ac i2c_acpi_ec i2c_core dm_mod md_mod sr_mod sbp2 scsi_mod lp
pcmcia 8139cp parport_pc parport 8139too mii yenta_socket rsrc_nonst
atic pcmcia_core joydev ath_pci ath_rate_sample wlan ath_hal pcspkr tsdev
snd_atiixp snd_atiixp_modem snd_ac97_codec snd_ac97_bus snd_pcm_oss
snd_mixer_oss snd_pcm snd_timer psmouse serio_raw snd soundcore
snd_page_alloc shpchp pci_hotplug ati_agp agpgart evdev ext3 jbd
ide_generic e
hci_hcd ohci1394 ieee1394 ohci_hcd usbcore ide_cd cdrom ide_disk generic
atiixp thermal processor fan capability commoncap vga16fb vgastate fb
con tileblit font bitblit softcu
Jun 22 19:06:59 0x0001 kernel: sor
Jun 22 19:06:59 0x0001 kernel: [4294781.005000] CPU:    0
Jun 22 19:06:59 0x0001 kernel: [4294781.005000] EIP:
0060:[pg0+409702306/1069184000]    Tainted: P      VLI
Jun 22 19:06:59 0x0001 kernel: [4294781.005000] EFLAGS: 00010296
(2.6.15-23-686)
Jun 22 19:06:59 0x0001 kernel: [4294781.005000] EIP is at
zz0b69b07c+0x5e/0xa8 [ath_hal]
Jun 22 19:06:59 0x0001 kernel: [4294781.005000] eax: 00000000   ebx:
d4e18000   ecx: cc6cde12   edx: 00000000
Jun 22 19:06:59 0x0001 kernel: [4294781.005000] esi: 00000000   edi:
d4e18000   ebp: d4e18000   esp: cc6cde00
Jun 22 19:06:59 0x0001 kernel: [4294781.005000] ds: 007b   es: 007b   ss:
0068
Jun 22 19:06:59 0x0001 kernel: [4294781.005000] Process macchanger (pid:
5291, threadinfo=cc6cc000 task=cf4f7030)
Jun 22 19:06:59 0x0001 kernel: [4294781.005000] Stack: d8b0b7fc d4e18000
d8b1098d d4e18000 00000000 d8b0b7fc 00000000 d4e18000
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]        d8b0b8f0 d4e18000
d4e182c8 00000001 00000000 d4e1007b 0000007b ffffffef
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]        d8b0a47f 00000060
00000206 00000000 d8a9e806 d4e18000 00000000 00000000
Jun 22 19:06:59 0x0001 kernel: [4294781.005000] Call Trace:
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]
[pg0+409683964/1069184000] zz0002dbd2+0x0/0xd30 [ath_hal]
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]
[pg0+409704845/1069184000] zz0016d872+0x15/0x1ac [ath_hal]
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]
[pg0+409683964/1069184000] zz0002dbd2+0x0/0xd30 [ath_hal]
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]
[pg0+409684208/1069184000] zz0002dbd2+0xf4/0xd30 [ath_hal]
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]
[pg0+409678975/1069184000] zz0016da50+0x1b/0x28 [ath_hal]
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]
[pg0+409237510/1069184000] ath_stoprecv+0x46/0x110 [ath_pci]
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]
[pg0+409237281/1069184000] ath_draintxq+0x71/0x110 [ath_pci]
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]
[pg0+409683964/1069184000] zz0002dbd2+0x0/0xd30 [ath_hal]
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]
[pg0+409198408/1069184000] ath_reset+0x88/0x240 [ath_pci]
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]
[pg0+409248272/1069184000] ath_set_mac_address+0xa0/0x150 [ath_pci]
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]
[dev_set_mac_address+94/128] dev_set_mac_address+0x5e/0x80
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]  [dev_ioctl+530/752]
dev_ioctl+0x212/0x2f0
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]  [do_ioctl+59/160]
do_ioctl+0x3b/0xa0
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]  [vfs_ioctl+107/560]
vfs_ioctl+0x6b/0x230
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]  [sys_ioctl+136/160]
sys_ioctl+0x88/0xa0
Jun 22 19:06:59 0x0001 kernel: [4294781.005000]
[sysenter_past_esp+84/117] sysenter_past_esp+0x54/0x75
Jun 22 19:06:59 0x0001 kernel: [4294781.005000] Code: 00 00 00 00 00 00 83
c4 18 5b c3 89 f6 56 53 8b 74 24 10 8b 5c 24 0c ba 00 00 00 00 90 8
d 04 92 8d 04 42 66 8b 84 c3 34 2a 00 00 <66> 3b 06 75 05 89 d0 eb 3c 90
8d 04 92 8d 04 42 8d 8c c3 30 2a

Change History

07/18/06 13:18:34 changed by cantona

look like it is HAL v0.9.17.2 ath_hal_reset() problem (called by function ath_reset() inside ath_set_mac_address), v0.9.16.16 work fine..

07/26/06 13:10:34 changed by anonymous

See related ticket: Ticket #323?

02/24/07 05:01:27 changed by proski

  • status changed from new to closed.
  • resolution set to fixed.

Fixed in r2156